local RS = RingSlinger

//Weapon bar (main and sub weapon display)
local weapons = function(v, player, mo, cam)
	local y = (170 + mo.ringslinger.hudy) * FRACUNIT
	for i = 1, 2
		local weapon = RS.Weapons[mo.ringslinger.loadout[i]]
		local patch = v.cachePatch(weapon.hudsprite)
		
		local xoff
		if i == 1
			xoff = -10
		else
			xoff = 10
		end
		local x = (160 + xoff) * FRACUNIT
		local trans = ((mo.ringslinger.wepslot == i) and V_HUDTRANS) or V_HUDTRANSHALF
		local scale = FRACUNIT
		if i == 1
			scale = FRACUNIT*4/3
		end
		
		v.drawScaled(x, y, scale, patch, trans|V_SNAPTOBOTTOM)
	end
	local xoff = 10
	local scale = FRACUNIT
	if mo.ringslinger.wepslot == 1
		xoff = -10
		scale = FRACUNIT*4/3
	end
	local x = (160 + xoff) * FRACUNIT
	local patch = v.cachePatch("CURWEAP")
	v.drawScaled(x, y, scale, patch, V_HUDTRANS|V_SNAPTOBOTTOM)
	
	--Ammo / reload display
	x = 160
	y = 110
	if mo.ringslinger.reload
		if mo.ringslinger.reload % 2
			v.drawString(x, y, "RELOAD", V_HUDTRANSHALF, "thin-center")
		end
		local barlength = mo.ringslinger.reload
		v.drawFill(x - barlength/2, y+8, barlength, 4, 7)
	else
		if mo.ringslinger.weapondelay
			local barlength = mo.ringslinger.weapondelay * 2/3
			v.drawFill(x - barlength/2, y+8, barlength, 1, 7)
		end
		local col = 0
		if mo.ringslinger.ammo >= 10
			x = $ + 1
		else
			col = V_REDMAP
		end
		v.drawString(x, y, tostring(mo.ringslinger.ammo), V_HUDTRANSHALF | col, "thin-center")
	end
	if mo.ringslinger.lostrings and mo.ringslinger.lostringstimer
		x = 160 + mo.ringslinger.lostringsxoff
		y = 174
		v.drawString(x, y, "-"+tostring(mo.ringslinger.lostrings), (mo.ringslinger.lostringstimer % 2) and V_HUDTRANS or V_HUDTRANSHALF, "thin-center")
	end
	
	--Ring penalty display
	if mo.ringslinger.reloadcosthud and mo.ringslinger.reloadcosthud % 2
		v.drawString(hudinfo[HUD_RINGSNUM].x + 24, hudinfo[HUD_RINGSNUM].y + 2, "-20", V_HUDTRANS | hudinfo[HUD_RINGSNUM].f)
	end
end

//Powerup display
local powerups = function(v, player, mo, cam)
	local yoff = 0
	for i = 1, #RS.Powers
		if not mo.ringslinger.powers[i]
			continue
		end
		local x = 16
		local y = 50 + yoff
		yoff = $ + 12
		local barlength = mo.ringslinger.powers[i] / 5
		local power = RS.Powers[i]
		v.drawFill(x, y, barlength, 9, V_SNAPTOLEFT + power.hudcolor)
		if (mo.ringslinger.powers[i] < 2*TICRATE) and (leveltime % 2)
			continue
		end
		v.drawString(x + 1, y + 1, power.name, V_SNAPTOLEFT | V_HUDTRANS, "thin")
	end
end

//Show your character holding the ring in firstperson
local holdingring = function(v, player, mo, cam)
	if cam.chase
		return
	end
	local weapon = RS.Weapons[mo.ringslinger.loadout[mo.ringslinger.wepslot]]
	local patch = v.cachePatch(weapon.viewsprite)
	local col = v.getColormap(TC_DEFAULT, player.skincolor)
	local scale = (weapon.scale or FRACUNIT) * 12/5
	local x, y
	if mo.ringslinger.swipe == 1
		x = 115*FRACUNIT
		y = 232*FRACUNIT
	else
		x = 230*FRACUNIT + mo.ringslinger.bobx
		y = 220*FRACUNIT + mo.ringslinger.boby + (weapon.viewoffset or 0)
	end
	v.drawScaled(x, y, scale, patch, V_SNAPTOBOTTOM|V_SNAPTORIGHT, col)
	
	if mo.ringslinger.swipe
		patch = v.cachePatch("SWIPE"+mo.ringslinger.swipe)
		v.draw(0, 0, patch, V_60TRANS|V_SNAPTOBOTTOM, col)
	end
end

//Add the hud
hud.add(function(v, player, cam)
	if not (player.mo and player.mo.valid and player.mo.ringslinger and player.playerstate == PST_LIVE)
		return
	end
	local mo = player.mo
	holdingring(v, player, mo, cam)
	weapons(v, player, mo, cam)
	powerups(v, player, mo, cam)
end, 'game')

hud.disable("weaponrings")